"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var angular_1 = require("@nstudio/angular");
var schematics_1 = require("@angular-devkit/schematics");
var xplat_1 = require("@nstudio/xplat");
function default_1(options) {
    var featureSettings = xplat_1.XplatFeatureHelpers.prepare(options);
    var chains = [];
    if (options.onlyProject) {
        var _loop_1 = function (projectName) {
            var projectParts = projectName.split('-');
            var platPrefix = projectParts[0];
            var platSuffix = projectParts.pop();
            if (platPrefix === 'web' || platSuffix === 'web') {
                // check for 2 different naming conventions on routing modules
                var routingModulePathOptions_1 = [];
                var appDirectory_1 = "apps/" + projectName + "/src/app/";
                routingModulePathOptions_1.push(appDirectory_1 + "app.routing.ts");
                routingModulePathOptions_1.push(appDirectory_1 + "app-routing.module.ts");
                chains.push(function (tree, context) {
                    return xplat_1.XplatFeatureHelpers.addFiles(options, platPrefix, projectName)(tree, context);
                });
                if (options.routing) {
                    chains.push(function (tree, context) {
                        return angular_1.adjustRouting(options, routingModulePathOptions_1, platPrefix)(tree, context);
                    });
                    if (options.adjustSandbox) {
                        chains.push(function (tree, context) {
                            return angular_1.adjustSandbox(options, platPrefix, appDirectory_1)(tree, context);
                        });
                    }
                }
                if (!options.onlyModule) {
                    chains.push(function (tree, context) {
                        return xplat_1.XplatFeatureHelpers.addFiles(options, platPrefix, projectName, '_component')(tree, context);
                    });
                }
            }
        };
        for (var _i = 0, _a = featureSettings.projectNames; _i < _a.length; _i++) {
            var projectName = _a[_i];
            _loop_1(projectName);
        }
    }
    else {
        // projectChains.push(noop());
        chains.push(function (tree, context) {
            return xplat_1.XplatFeatureHelpers.addFiles(options, 'web', null, null, 'angular')(tree, context);
        });
        // update index
        chains.push(function (tree, context) {
            var xplatFolderName = xplat_1.XplatHelpers.getXplatFoldername('web', 'angular');
            return xplat_1.XplatFeatureHelpers.adjustBarrelIndex(options, "xplat/" + xplatFolderName + "/features/index.ts")(tree, context);
        });
        // add starting component unless onlyModule
        if (!options.onlyModule) {
            chains.push(function (tree, context) {
                return xplat_1.XplatFeatureHelpers.addFiles(options, 'web', null, '_component', 'angular')(tree, context);
            });
        }
    }
    return schematics_1.chain([xplat_1.prerun()].concat(chains));
}
exports.default = default_1;
