"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var schematics_1 = require("@angular-devkit/schematics");
var xplat_1 = require("@nstudio/xplat");
var xplat_2 = require("../../utils/xplat");
function default_1(options) {
    return schematics_1.chain([
        xplat_1.prerun(options, true),
        function (tree, context) {
            var xplatFolderName = xplat_1.XplatHelpers.getXplatFoldername('web', 'angular');
            // console.log('xplatName:', xplatName);
            return options.skipDependentPlatformFiles
                ? schematics_1.noop()
                : xplat_1.XplatHelpers.addPlatformFiles(options, xplatFolderName)(tree, context);
        },
        function (tree, context) {
            var xplatFolderName = xplat_1.XplatHelpers.getXplatFoldername('web', 'angular');
            if (tree.exists("/xplat/" + xplatFolderName + "/scss/_index.scss")) {
                // may have already generated vanilla web support
                return schematics_1.noop()(tree, context);
            }
            else {
                return schematics_1.branchAndMerge(schematics_1.mergeWith(schematics_1.apply(schematics_1.url("./_scss_files"), [
                    schematics_1.template(__assign({}, options, xplat_1.getDefaultTemplateOptions())),
                    schematics_1.move("xplat/" + xplatFolderName + "/scss")
                ])))(tree, context);
            }
        },
        function (tree, context) {
            if (tree.exists('/libs/scss/_index.scss')) {
                // user may have generated support already
                return schematics_1.noop()(tree, context);
            }
            else {
                return schematics_1.branchAndMerge(schematics_1.mergeWith(schematics_1.apply(schematics_1.url("./_lib_files"), [
                    schematics_1.template(__assign({}, options, xplat_1.getDefaultTemplateOptions())),
                    schematics_1.move('libs')
                ])))(tree, context);
            }
        },
        xplat_1.XplatHelpers.updateTsConfigPaths(options, { framework: 'angular' }),
        xplat_2.XplatWebAngularHelpers.updateRootDeps(options)
    ]);
}
exports.default = default_1;
